#property copyright "forexway"
#property link      "http://www.forexway.ru"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Blue
#property indicator_color2 ForestGreen
#property indicator_color3 Red

extern int period = 27;
extern string INFORMATION = ""; //"www.forexway.ru";
double g_ibuf_88[];
double g_ibuf_92[];
double g_ibuf_96[];

int init() {
   SetIndexStyle(0, DRAW_NONE);
   SetIndexStyle(1, DRAW_HISTOGRAM, STYLE_SOLID, 2, ForestGreen);
   SetIndexStyle(2, DRAW_HISTOGRAM, STYLE_SOLID, 2, Red);
   IndicatorDigits(Digits + 1);
   SetIndexBuffer(0, g_ibuf_88);
   SetIndexBuffer(1, g_ibuf_92);
   SetIndexBuffer(2, g_ibuf_96);
   IndicatorShortName("forexway");
   SetIndexLabel(1, NULL);
   SetIndexLabel(2, NULL);
   return (0);
}

int start() {
   double ld_8;
   double ld_16;
   double ld_80;
   int li_4 = IndicatorCounted();
   double ld_32 = 0;
   double ld_40 = 0;
   double ld_unused_48 = 0;
   double ld_unused_56 = 0;
   double ld_64 = 0;
   double ld_unused_72 = 0;
   double l_low_88 = 0;
   double l_high_96 = 0;
   if (li_4 > 0) li_4--;
   int li_0 = Bars - li_4;
   for (int li_104 = 0; li_104 < li_0; li_104++) {
      l_high_96 = High[iHighest(NULL, 0, MODE_HIGH, period, li_104)];
      l_low_88 = Low[iLowest(NULL, 0, MODE_LOW, period, li_104)];
      ld_80 = (High[li_104] + Low[li_104]) / 2.0;
      ld_32 = 0.66 * ((ld_80 - l_low_88) / (l_high_96 - l_low_88) - 0.5) + 0.67 * ld_40;
      ld_32 = MathMin(MathMax(ld_32, -0.999), 0.999);
      g_ibuf_88[li_104] = MathLog((ld_32 + 1.0) / (1 - ld_32)) / 2.0 + ld_64 / 2.0;
      ld_40 = ld_32;
      ld_64 = g_ibuf_88[li_104];
   }
   bool li_108 = TRUE;
   for (li_104 = li_0 - 2; li_104 >= 0; li_104--) {
      ld_16 = g_ibuf_88[li_104];
      ld_8 = g_ibuf_88[li_104 + 1];
      if ((ld_16 < 0.0 && ld_8 > 0.0) || ld_16 < 0.0) li_108 = FALSE;
      if ((ld_16 > 0.0 && ld_8 < 0.0) || ld_16 > 0.0) li_108 = TRUE;
      if (!li_108) {
         g_ibuf_96[li_104] = ld_16;
         g_ibuf_92[li_104] = 0.0;
      } else {
         g_ibuf_92[li_104] = ld_16;
         g_ibuf_96[li_104] = 0.0;
      }
   }
   return (0);
}
